Subject: [Dime] [Technical Errata Reported] RFC6733 (5084)

From: RFC Errata System <[email-masked]>
Date: Thu, 10 Aug 2017 21:04:56 -0700 (PDT)

The following errata report has been submitted for RFC6733,
"Diameter Base Protocol".

--------------------------------------
You may review the report below and at:
http://www.rfc-editor.org/errata/eid5084

--------------------------------------
Type: Technical
Reported by: Priyatosh Mandal <[email-masked]>

Section: 8.16

Original Text
-------------
By including Origin-State-Id in a message, it allows other Diameter
entities to infer that sessions associated with a lower Origin-State-Id 
are no longer active.
If an access device does not intend for such inferences to be made, it 
MUST either not include Origin-State-Id in any message or set its value 
to 0.

Corrected Text
--------------
By including Origin-State-Id in a message, it allows other Diameter
entities to infer that sessions associated with a lower Origin-State-Id 
are no longer active.
If an access device does not intend for such inferences to be made, it 
MUST either not include Origin-State-Id in any message or set its value 
to 0. 
As a special case when the value of Origin-State-Id changes from 
4294967295 to 0, then also the access device  clear all the sessions.

Notes
-----
Origin-State-Id is defined as Unsigned32 in RFC 6733, Section 8.16. So the maximum 
value it can have is 4294967295. If the system restarts many times and the value of
Origin-State-Id reaches the value which is same as its maximum value 4294967295. 
Then what will happen for the next restart. At the next restart the value of Origin-State-Id 
will be 0 if we try to increase the value of Origin-State-Id.
It is not defined in the RFC 6733, that how the system should behave after 4294967295-th 
restart with respect to Origin-State-Id.

Generally when the peer receives an increased value of Origin-State-Id, then it clear all sessions.
If the value of Origin-State-Id reaches its maximum i.e., 4294967295, then after another restart 
its value will be 0. For a special case for transition of value of Origin-State-Id from 
4294967295 to 0, the peer should clear its session.

Instructions:
-------------
This erratum is currently posted as "Reported". If necessary, please
use "Reply All" to discuss whether it should be verified or
rejected. When a decision is reached, the verifying party  
can log in to change the status and edit the report, if necessary. 

--------------------------------------
RFC6733 (draft-ietf-dime-rfc3588bis-33)
--------------------------------------
Title               : Diameter Base Protocol
Publication Date    : October 2012
Author(s)           : V. Fajardo, Ed., J. Arkko, J. Loughney, G. Zorn, Ed.
Category            : PROPOSED STANDARD
Source              : Diameter Maintenance and Extensions
Area                : Operations and Management
Stream              : IETF
Verifying Party     : IESG

---

From: "Priyatosh Mandal" <[email-masked]>
Date: Mon, 14 Aug 2017 09:46:39 +0530

Dear All,
Kindly verify this.

Regards,
Priyatosh Mandal

On Thu, 10 Aug 2017 21:04:56 -0700 (PDT), RFC Errata System wrote
The following errata report has been submitted for RFC6733, 
 "Diameter Base Protocol".

 Section: 8.16

 Original Text 
 ------------- 

 Corrected Text 
 -------------- 

 Notes 
 ----- 

 Instructions: 
 ------------- 

Priyatosh 
Ext: 8517 
Mob: 9810480266 
-------------------------------------------------------------------------------- 
::Disclaimer:: 
-------------------------------------------------------------------------------- 
The contents of this email and any attachment(s) are confidential and intended 
for the named recipient(s) only. It shall not attach any liability on C-DOT. 
Any views or opinions presented in this email are solely those of the author 
and  may  not  necessarily  reflect  the  opinions

---

From: Yuval Lifshitz <[email-masked]>
Date: Mon, 14 Aug 2017 09:40:13 +0000

Hi Priyatosh,
Think the following addition may be more correct:
…
As a special case when the value of Origin-State-Id changes from
4294967295 to 0, other Diameter entities MAY infer that all sessions were cleared.

Best Regards,

Yuval

From: DiME [mailto:[email-masked]] On Behalf Of Priyatosh Mandal
Sent: Monday, August 14, 2017 7:17 AM
To: RFC Errata System; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]
Cc: [email-masked]
Subject: Re: [Dime] [Technical Errata Reported] RFC6733 (5084)

Dear All,
Kindly verify this.

Regards,
Priyatosh Mandal

--------------------------------------
Type: Technical
Reported by: Priyatosh Mandal <[email-masked]<mailto:[email-masked]>>

Section: 8.16

Original Text
-------------

Corrected Text
--------------

Notes
-----

Instructions:
-------------

Priyatosh
Ext: 8517
Mob: 9810480266

---

From: Dave Dolson <[email-masked]>
Date: Mon, 14 Aug 2017 10:51:25 +0000

In my opinion, the change should not be accepted.
In your roll-over special case, the device should skip over the value 0, using 1 or some other value instead of zero.

David Dolson
Sandvine
From: Priyatosh Mandal
Sent: Monday, August 14, 2017 12:57 AM
To: RFC Errata System; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]
Cc: [email-masked]
Subject: Re: [Dime] [Technical Errata Reported] RFC6733 (5084)

Dear All,
Kindly verify this.

Regards,
Priyatosh Mandal

Section: 8.16

Original Text
-------------

Corrected Text
--------------

Notes
-----

Instructions:
-------------

Priyatosh
Ext: 8517
Mob: 9810480266

---

From: "Priyatosh Mandal" <[email-masked]>
Date: Mon, 14 Aug 2017 16:48:34 +0530

Hello Sir,
The situation is a transition from the maximum value 4294967295 of Origin-State-Id. If after this, the value of Origin-State-Id is increased, it will automatically become 0. So the peer node which receives the value 0 after 4294967295, can assume the node which sent this 0,
faced a restart. Here the peer-node  is already aware that the previous value of origin-state-id was 4294967295. So it can easily conclude node restart.

I understand  the meaning of 0 as explained in RFC 6733 :"If an access device does not intend for such inferences to be made, it MUSTeither not include Origin-State-Id in any message or set its value to 0".
But this is a special case, where the value of Origin-State-Id changes from 4294967295 to 0.

So kindly reconsider this.

Thanking you,
Priyatosh

On Mon, 14 Aug 2017 10:51:25 +0000, Dave Dolson wrote
In my opinion, the change should not be accepted. 
 In your roll-over special case, the device should skip over the value 0, using 1 or some other value instead of zero.

 David Dolson
 Sandvine

 From: Priyatosh Mandal

 Dear All, 
 Kindly verify this.

 Regards, 
 Priyatosh Mandal

 Section: 8.16

 Original Text 
 ------------- 

 Corrected Text 
 -------------- 

 Notes 
 ----- 

 Instructions: 
 ------------- 

 Priyatosh 
 Ext: 8517 
 Mob: 9810480266 

Priyatosh 
Ext: 8517 
Mob: 9810480266

---

From: "Bertz, Lyle T [CTO]" <[email-masked]>
Date: Mon, 14 Aug 2017 13:01:51 +0000

I believe what Dave is alluding to is that if one *does intend for the inferences to be made* then rolling over the value to 0 is not appropriate and a value > 0, e.g. 1, MUST be used.

In a sense it is not an error as much as a note / warning for those who are allocating that AVP in a specific manner.

From: DiME [mailto:[email-masked]] On Behalf Of Priyatosh Mandal
Sent: Monday, August 14, 2017 6:19 AM
To: Dave Dolson <[email-masked]>; RFC Errata System <[email-masked]>; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]
Cc: [email-masked]
Subject: Re: [Dime] [Technical Errata Reported] RFC6733 (5084)

Hello Sir,

I understand  the meaning of 0 as explained in RFC 6733 :"If an access device does not intend for such inferences to be made, it MUST either not include Origin-State-Id in any message or set its value to 0".

Thanking you,
Priyatosh

David Dolson
Sandvine

From: Priyatosh Mandal
Sent: Monday, August 14, 2017 12:57 AM
To: RFC Errata System; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Cc: [email-masked]<mailto:[email-masked]>
Subject: Re: [Dime] [Technical Errata Reported] RFC6733 (5084)

Dear All,
Kindly verify this.

Regards,
Priyatosh Mandal

--------------------------------------
You may review the report below and at:
http://www.rfc-editor.org/errata/eid5084<https://na01.safelinks.protection.outlook.com/?url=http%3A%2F%2Fwww.rfc-editor.org%2Ferrata%2Feid5084&data=02%7C01%7Clyle.t.bertz%40sprint.com%7C627e5f999b6e4750fae408d4e313a562%7C4f8bc0acbd784bf5b55f1b31301d9adf%7C0%7C0%7C636383120901606733&sdata=rzTCFkfc7KCzGxNhdCsnCjVSFOVui9lJyAmsWKxdThA%3D&reserved=0>

Section: 8.16

Original Text
-------------

Corrected Text
--------------

Notes
-----

Instructions:
-------------

Priyatosh
Ext: 8517
Mob: 9810480266

Priyatosh
Ext: 8517
Mob: 9810480266

________________________________

This e-mail may contain Sprint proprietary information intended for the sole use of the recipient(s). Any use by others is prohibited. If you are not the intended recipient, please contact the sender and delete all copies of the message.

---

From: Priyatosh Mandal <[email-masked]>
Date: Mon, 14 Aug 2017 19:47:28 +0530

Kindly note that, with the incremental change of this origin-state-id the
peer node clear sessions. So when the change is from the maximum value to
the minimum value of origin-state-id then it is not an incremental change.
This is an exceptional situation, which I feel to be part of rfc.

Regards,
Dr. Priyatosh Mandal, Ph. D.

On Aug 14, 2017 6:32 PM, "Bertz, Lyle T [CTO]" <[email-masked]>
wrote:

> I believe what Dave is alluding to is that if one **does intend for the
> inferences to be made** then rolling over the value to 0 is not
> appropriate and a value > 0, e.g. 1, MUST be used.
>
>
>
> In a sense it is not an error as much as a note / warning for those who
> are allocating that AVP in a specific manner.
>
>
>
> *From:* DiME [mailto:[email-masked]] *On Behalf Of *Priyatosh
> Mandal
> *Sent:* Monday, August 14, 2017 6:19 AM
> *To:* Dave Dolson <[email-masked]>; RFC Errata System <
> [email-masked]>; [email-masked]; [email-masked];
> [email-masked]; [email-masked]; [email-masked];
> [email-masked]; [email-masked]; [email-masked]
> *Cc:* [email-masked]
> *Subject:* Re: [Dime] [Technical Errata Reported] RFC6733 (5084)
>
>
>
> Hello Sir,
> The situation is a transition from the maximum value 4294967295 of
> Origin-State-Id. If after this, the value of Origin-State-Id is increased,
> it will automatically become 0. So the peer node which receives the value 0
> after 4294967295, can assume the node which sent this 0,
> faced a restart. Here the peer-node  is already aware that the previous
> value of origin-state-id was 4294967295. So it can easily conclude node
> restart.
>
> I understand  the meaning of 0 as explained in RFC 6733 :"If an access
> device does not intend for such inferences to be made, it MUST either not
> include Origin-State-Id in any message or set its value to 0".
>
> *On Mon, 14 Aug 2017 10:51:25 +0000, Dave Dolson wrote*
> In your roll-over special case, the device should skip over the value 0,
> using 1 or some other value instead of zero.
>
> David Dolson
> Sandvine
>
>
>
> *From: *Priyatosh Mandal
> *Sent: *Monday, August 14, 2017 12:57 AM
> *To: *RFC Errata System; [email-masked]; [email-masked];
> [email-masked]; [email-masked]; [email-masked];
> [email-masked]; [email-masked]; [email-masked]
> *Cc: [email-masked]
> *Subject: *Re: [Dime] [Technical Errata Reported] RFC6733 (5084)
>
>
>
> Dear All,
> Kindly verify this.
>
> Regards,
> Priyatosh Mandal
>
> *On Thu, 10 Aug 2017 21:04:56 -0700 (PDT), RFC Errata System wrote*
> <https://na01.safelinks.protection.outlook.com/?url=http%3A%2F%2Fwww.rfc-editor.org%2Ferrata%2Feid5084&data=02%7C01%7Clyle.t.bertz%40sprint.com%7C627e5f999b6e4750fae408d4e313a562%7C4f8bc0acbd784bf5b55f1b31301d9adf%7C0%7C0%7C636383120901606733&sdata=rzTCFkfc7KCzGxNhdCsnCjVSFOVui9lJyAmsWKxdThA%3D&reserved=0>
>
> ------------------------------
>
> This e-mail may contain Sprint proprietary information intended for the
> sole use of the recipient(s). Any use by others is prohibited. If you are
> not the intended recipient, please contact the sender and delete all copies
> of the message.
>

---

From: "Priyatosh Mandal" <[email-masked]>
Date: Wed, 16 Aug 2017 09:08:56 +0530

Hello ,
Should I consider the Reported Errata ID: 5084, as rejected.

Kindly confirm.

Regards,
Dr. Priyatosh Mandal, Ph.D.

On Mon, 14 Aug 2017 19:47:28 +0530, Priyatosh Mandal wrote
Kindly note that, with the incremental change of this origin-state-id the peer node clear sessions. So when the change is from the maximum value to the minimum value of origin-state-id then it is not an incremental change. This is an exceptional situation, which I feel to be part of rfc. 

 Regards, 

 On Aug 14, 2017 6:32 PM, "Bertz, Lyle T [CTO]" <[email-masked]> wrote:

 I believe what Dave is alluding to is that if one *does intend for the inferences to be made* then rolling over the value to 0 is not appropriate and avalue > 0, e.g. 1, MUST be used. 

 From: DiME [mailto:[email-masked]]On Behalf Of Priyatosh Mandal
 Sent: Monday, August 14, 2017 6:19 AM
 To: Dave Dolson <[email-masked]>; RFC Errata System <[email-masked]>; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]
 Cc: [email-masked]
 Subject: Re: [Dime] [Technical Errata Reported] RFC6733 (5084)
  
 Hello Sir, 
 The situation is a transition from the maximum value 4294967295 of Origin-State-Id. If after this, the value of Origin-State-Id is increased, it will automatically become 0. So the peer node which receives the value 0 after 4294967295, can assume the node whichsent this 0, 
 faced a restart. Here the peer-node  is already aware that the previous value of origin-state-id was 4294967295. So it can easily conclude node restart.

 I understand  the meaning of 0 as explained in RFC 6733 :"If an access device does not intend for such inferences to be made, it MUST either not include Origin-State-Id in any message or set its value to 0".But this is a special case, where the value of Origin-State-Id changes 
from  4294967295 to 
0.

 So kindly reconsider 
this. 

 Thanking you, 
 Priyatosh

 David Dolson 
 Sandvine

 From: Priyatosh Mandal 
 Sent: Monday, August 14, 2017 12:57 AM 
 To: RFC Errata System; [email-masked];[email-masked]; [email-masked]; [email-masked];[email-masked]; [email-masked]; [email-masked];[email-masked] 
 Cc: [email-masked] 
 Subject: Re: [Dime] [Technical Errata Reported] RFC6733 (5084)

 Dear All, 
 Kindly verify this.

 Regards, 
 Priyatosh Mandal

 Section: 8.16

 Original Text 
 ------------- 

 Corrected Text 
 -------------- 

 Notes 
 ----- 

 Instructions: 
 ------------- 

 Priyatosh 
 Ext: 8517 
 Mob: 9810480266 

 Priyatosh 
 Ext: 8517 
 Mob: 9810480266 

-----------------------------------------------------------------------

Priyatosh 
Ext: 8517 
Mob: 9810480266

---

From: Dave Dolson <[email-masked]>
Date: Wed, 16 Aug 2017 16:30:45 +0000

Priyatosh,
You are asking for a change in interpretation that is not backwards compatible.
I'm suggesting a backwards compatible clarification would be that for the rollover case, the agent should skip the value of zero.

David Dolson
Sandvine
From: Priyatosh Mandal
Sent: Monday, August 14, 2017 10:17 AM
To: Bertz, Lyle T [CTO]
Cc: Dave Dolson; [email-masked]; RFC Errata System; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; Priyatosh Mandal
Subject: RE: [Dime] [Technical Errata Reported] RFC6733 (5084)

Regards,

On Aug 14, 2017 6:32 PM, "Bertz, Lyle T [CTO]" <[email-masked]<mailto:[email-masked]>> wrote:
I believe what Dave is alluding to is that if one *does intend for the inferences to be made* then rolling over the value to 0 is not appropriate and a value > 0, e.g. 1, MUST be used.

From: DiME [mailto:[email-masked]<mailto:[email-masked]>] On Behalf Of Priyatosh Mandal
Sent: Monday, August 14, 2017 6:19 AM
To: Dave Dolson <[email-masked]<mailto:[email-masked]>>; RFC Errata System <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Cc: [email-masked]<mailto:[email-masked]>
Subject: Re: [Dime] [Technical Errata Reported] RFC6733 (5084)

Hello Sir,

Thanking you,
Priyatosh

David Dolson
Sandvine

From: Priyatosh Mandal

Dear All,
Kindly verify this.

Regards,
Priyatosh Mandal

Section: 8.16

Original Text
-------------

Corrected Text
--------------

Notes
-----

Instructions:
-------------

Priyatosh
Ext: 8517
Mob: 9810480266

Priyatosh
Ext: 8517
Mob: 9810480266

---

From: Priyatosh Mandal <[email-masked]>
Date: Wed, 16 Aug 2017 22:11:40 +0530

Sir,
Consider the situation of increment of origin-state-id from maximum to the
next will be 0 only. The  node which will be sending 0, has to modify the
value internally to 1, before sending to peer. Here also the peer receiving
the information will be confused what to do with that? Because it is not an
incremented value. So this has to be explained somewhere. Also this is not
probably backward compatible.
Regards,
Dr. Priyatosh Mandal, Ph. D.

On Aug 16, 2017 10:00 PM, "Dave Dolson" <[email-masked]> wrote:

> I'm suggesting a backwards compatible clarification would be that for the
> rollover case, the agent should skip the value of zero.
>
>
> David Dolson
> Sandvine
> *From: *Priyatosh Mandal
> *Sent: *Monday, August 14, 2017 10:17 AM
> *To: *Bertz, Lyle T [CTO]
> *Cc: *Dave Dolson; [email-masked]; RFC Errata System;
> [email-masked]; [email-masked]; [email-masked];
> [email-masked]; [email-masked]; [email-masked];
> [email-masked]; [email-masked]; Priyatosh Mandal
> *Subject: *RE: [Dime] [Technical Errata Reported] RFC6733 (5084)
>